# -*- coding: iso-8859-1 -*-
"""
Dieses Modul definiert nur eine kleine Dokumentklasse, die ein Formular
zur Bedienung des Proxies ausgibt.  schwob.py erzeugt dieses Dokument,
wenn es nichts weiter bergeben bekommt.  Ihr solltet eine hnliche
Funktionalitt auf euren eigenen Seiten unterbringen.
"""

import common

indexHtml = "\n".join(['<head><title>Testseite</title></head>'
			'<body>',
			'<form method="get" action="%(proxyURL)s">',
			'<input type="text" size="60" name="schwob_url">',
			'<input type="submit" value="Nach Schwaben">',
			'</form>'
			'<form method="get" action="%(proxyURL)s">',
			'<input type="text" size="60" name="sax_url">',
			'<input type="submit" value="Nach Sachsen">',
			'</form>'
			'<form method="get" action="%(proxyURL)s">',
			'<input type="text" size="60" name="frank_url">',
			'<input type="submit" value="Nach Franken">',
			'</form>',])

robotsTxt = "\n".join(['User-agent: *',
	'Disallow: /',
	''
])

class Document:
	def __init__(self, request):
		self.proxyURL = common.proxyHomeURL
		if request.path_info.endswith("robots.txt"):
			self.data = robotsTxt
			self.content_type = "text/plain"
		else:
			self.data = indexHtml
			self.content_type = "text/html"
	
	def getData(self):
		return self.data%{
			'proxyURL': self.proxyURL,
		}

	def getFooter(self):
		if self.content_type.startswith("text/html"):
			return "<body>"
		else:
			return ""
