#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-
"""
Dies hier ist eine stripped-down-Version des Handlers fr den UNiMUT.
Rausgenommen haben wir u.a.: HEAD-Requests und gzip transfer encoding.
Es wre nicht schwer, das bei Bedarf wieder reinzubauen, aber hier
gehts erstmal darum, den Kram so simpel wie mglich zu halten.
"""

import os
import sys
import traceback
import re
import cgi
import time

import translator
import index
import common

class Request:
	"""Eine Klasse, die die Schnittstelle zum Webserver abstrahiert
	(wird im UNiMUT fr einen Haufen Kram gebraucht, den wir hier
	nicht brauchen -- aber schwob knnte so recht schnell auf mod_python
	umgestellt werden.)
	"""
	def __init__(self):
		self.unparsedURI = os.environ["REQUEST_URI"]
		if os.environ.has_key("PATH_INFO"):
			self.path_info = os.environ["PATH_INFO"]
		else:
			self.path_info = re.sub(r"\?.*", "", self.unparsedURI)
		self.form = cgi.FieldStorage()

	def log(self, s):
		sys.stderr.write("\n\n%s: %s\n----\n"%(time.asctime(), s))

def printError(msg):
	print "Content-Type: text/plain"
	print "Status: 500"
	print ""
	print "Ein Fehler ist aufgetreten:"
	print msg

def output(doc):
	stuff = doc.getData()+doc.getFooter()
	print "Content-Type: %s"%doc.content_type
	print "Content-Length: %d"%len(stuff)
	print ""
	print stuff

def dispatch(request):
	for key in request.form.keys():
		if key in translator.langFilters.keys():
			return translator.Document(request)
	else:
		return index.Document(request)


if __name__=="__main__":
	try:
		request = Request()
		try:
			answer = dispatch(request)
			output(answer)
		except common.Error, msg:
			printError(msg)
		except common.Redirect, msg:
			print "Status: 301 Moved Permanently"
			print "Content-Type: text/html"
			print "Location: %s"%str(msg)
			print "Connection: close"
			print ""
			print '<head><title>Moved Permanently</title></head>'
			print '<body><p>Du solltest das ja eigentlich nicht sehen, aber'
			print 'weils nun schon mal passiert ist: Klicke'
			print '<a href="%s">hier</a>.</p></body>'%str(msg)
	except:
		import StringIO
		strFile = StringIO.StringIO()
		traceback.print_exc(None,strFile)
		print "Status: 500 CGI Error"
		print "Connection: close"
		print "content-type: text/html"
		print ""
		print "<head><title>Schwerer Fehler</title><head>"
		print "<body>"
		print ('<p>Bser Fehler.  Bitte das Folgende an <a href='
			'"mailto:%(maintainer)s">den Maintainer</a> dieser Seite'
			' schicken:</p><pre>%(traceback)s</pre>')%{
			"maintainer": common.maintainerAddress,
			"traceback": re.sub("\n","<BR>",
				re.sub(">","&gt;",
				re.sub("<","&lt;",
				strFile.getvalue())))
		}
		print "</body>"

# vi:ts=2:
